# Spine login example

## Overview

This example project was written as a simple execution of doing server side authentication and binding the client side templates to reflect login and logout states.


## Simplified Flow

App Loads and looks for a session cookie:

- Sessions controller looks for a session cookie via AJAX call to GET /sessions
  - If there isn't one, no biggie render default logged out state.
  - If express.js has a session it sends a user id back to spine as json
    - create record in Session spine model
    - a global window variable called `window.activeSession` is set to user id.
    - Login controller binds to "create" event of Session, renders the login.eco view

Logging In:

- Login controller handles a submit event on login form
  - POST /sessions and passes username and password as data.
  - User.js file on the node side handles auth
  - creates a cookie if auth succeeds
  - sends a user id back to spine as json
    - create record in Session spine model
    - a global window variable called `window.activeSession` is set to user id.
    - Login controller binds to "create" event of Session, renders the login.eco view

Logging Out:

- Login controller handles a click on the logout button
  - calls `Sessions.killSession`
  - AJAX to GET /sessions/destroy
  - `window.activeSession` is set back to NULL, Session record is destroyed
  - Login controller binds to "destroy" event of Session model, re-renders the login.eco view
  - node.js destroys the session cookie and deletes the session from MemoryStore.
    
## Relevant Files

If you're just cruising the files here on github the relevant spine files live:
	
	public/javascripts/app/app/

And to see the server side handling of the ajax requests check:

	app.js
	user.js

## Install

You will need to install node.js and npm to run this on your local machine

In this example I used `express.js` `spine.js`

To get it up and running:

	git clone git@github.com:EndOvAnEra/spine-login-example.git
	cd spine-login-example/
	npm install -d
	
	cd public/javascripts/app/
	npm install .
	
	
From the spine-login-example/ directory run the following to start your node server:
	
	node app.js
	
Navigate your browser to <http://localhost:3000>

Login with the creds:
	
	username: eO_Ae
	pass: bagels
	
Hope it helps! Please contact me with feedback <willieviseoae@gmail.com>
