Spine = require('spine')
Session = require('models/session')

class Login extends Spine.Controller
  events:
    "submit #auth_form": "authenticate"
    "click #logout": "logout"

  elements:
    "#auth_form": "auth_form"

  constructor: ->
    super
    Session.bind "create", @render
    Session.bind "destroy", @render
    @render()

  render: =>
    @html require('views/login')
    
  authenticate: (e) ->
    e.preventDefault()
    username = @auth_form.find("#username").val()
    password = @auth_form.find("#pass").val()
    $.ajax(
      type: "POST"
      url: "/sessions"
      data:
        username: username
        password: password
      success: (response) =>
        if response.fail?
          @sessions.failed(response, @proxy(@fail))
        else 
          @sessions.loadSession()
      error: (err) =>
        @log err
    )
    
  logout: ->
    @sessions.killSession()

  fail: =>
    $("#response").html("<p>Nope, that's wrong.</p>")

module.exports = Login
