Spine = require('spine')
$ = Spine.$
Session = require('models/session')

class Sessions extends Spine.Controller
  constructor: ->
    super
    @loadSession()
 
  failed: (response, callback) ->
    callback() if callback

  loadSession: ->
    $.ajax(
      type: "GET"
      url: "/sessions"
      success: (response) =>
        if response.userID?
          record = new Session(userID: response.userID)
          window.activeSession = record.authenticated()
          record.save()
      error: (err) =>
        @log err
        @html require('views/error')(err)
    )
    
  killSession: ->
    $.get('/sessions/destroy', ->
      console.log 'session destroyed'
    )
    delete window.activeSession
    Session.destroyAll()

module.exports = Sessions
